Program StepMotorsDriver;
Uses Graph,CRT,Dos;
Label CrashExit;
Type TypedTabType=(Info, Settings);
     SWs=(swRewrite, swAppend);
     LPTn=(LPT1,LPT2);
Const Arrow :Array[1..2,1..16] Of Word =((
       { Monitor Mask: }
       4095,2047,1023,511,255,127,63,31,15,15,127,4223,45183,63551,63551,64575),(
       { Mouse Mask: }
       0,16384,24576,28672,30720,31744,32256,32512,32640,31744,27648,17920,1536,768,768,0));
      Traser :Array[1..2,1..16] Of Word =((
       { Monitor Mask: }
       65407,52793,33808,32768,50145,58211,53113,36728,2056,36728,53113,58211,50145,32768,33808,52792),(
       { Mouse Mask: }
       0,128,12422,15342,8188,4088,8188,8188,32767,8188,8188,4088,8188,15342,12422,128));
{******* Port Adresses *******}
PortAdress: Array [LPTn] Of Word =($378,$278);
{*****************************}
Var Gm,Gd:Integer;
    StrUser:String[20];
{*******WINDOWS********}
    ImX,ImY: Array [1..50] of Integer;
    WinP:Byte;
    ImSize:Word;
    Win: Array[1..50] Of Pointer;
{***********************************}
{*******Mouse******}
 MouseInst,mX,mY,mTl:Word;
{******* Locals ********}
GoINZero,ChBoxC,RepeatSeq:boolean;
StepRepSEQ,SDP,YesExit,NoExit,Trase,Redraw:Boolean;
ExCode,Result,DosErr:Byte;
Period:Word;
PAP:LPTn;{Port Adress Pointer}
Key:Char;
{***** Database ****}
TCond: Array [0..7,0..15] Of Boolean;
TMPCond: Array [0..15] Of Boolean;
SCond: Array [0..7] Of Boolean;
Loop,Loop2,OldRelX,WaitSeq,OldTC,Speed:Byte;
StartTC,StopTC,TC:Byte;
NChanels:String[10];
CondName,CondNameTMP:String[40];
FileName,FileNameTMP:String[12];
PATH:String[80];
{*************************************}
{********** Interrupt Vectors **************}
OldTimerPtr:Pointer;
OldTimer8:Procedure;
{*******************************************}
{*********}
Procedure SignalsTab(X,Y:Word;TabType:TypedTabType;Active:Byte;Drawn:Boolean);Forward;
Procedure CurOn;Forward;
Procedure CurOff;Forward;
Procedure SetCursor(Segment,POffset:Word);Forward;
{************************* Traser *************************}
Procedure Pulser; Interrupt;
Begin
If Trase Then
   Begin
   inc(Period);
   If Period>=Speed Then
                Begin
                inc(TC);
                Period:=0;
                {SendData}
                If TC<>OldTC Then
                                Redraw:=True;
                OldTC:=TC;                     {inc(TC);}
                If (TC>StopTC) and (not (StepRepSEQ)) Then Begin
                TC:=0;
                Trase:=False;
                CurOff;
                {PortOff}
                SetCursor(Seg(Arrow),Ofs(Arrow));
                CurOn;
                SignalsTab(10,21,Info,TC,False);
                End;
                If StepRepSEQ Then
                  If TC>StopTC Then TC:=StartTC;
                End;
   End;
InLine($9c);
OldTimer8;
Port[$20]:=$20;
End;

Procedure CurOn;Assembler;
asm
mov Ax,1;
int 33h;
end;
Procedure CurOff;Assembler;
asm
mov Ax,2;
int 33h;
end;
Procedure WriteDosError(DosErr:Byte);
Begin
Case DosErr Of
            2:  WriteLn('File not found');
            3:  WriteLn('Path not found');
            5:  WriteLn('Access denied');
            6:  WriteLn('Invalid handle');
            8:  WriteLn('Not enough memory');
            10: WriteLn('Invalid environment');
            11: WriteLn('Invalid format');
            18: WriteLn('No more files');
            End;
End;
Procedure SetCursor(Segment,POffset:Word);Assembler;
asm
mov ax,9;
mov bx,1;
mov cx,1;
mov dx,POffset;
mov es,Segment;
int 33h;
end;

Procedure GetMPos(X,Y,Tl:Word);
Var mX,mY,mTl:Word;
Begin
Asm
mov Ax,3;
int 33h
mov mTl,Bx;
mov mX,Cx;
mov mY,Dx;
end;
X:=mX;
Y:=mY;
Tl:=mTl;
End;

Procedure OpenWindow(X1,Y1,X2,Y2:Integer;Caption:String);
Const FloodPattern : FillPatternType = ($FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF);
Begin
SetViewPort(0,0,639,479,False);
CurOff;
{Prepare Space}
inc(WinP);
ImSize:=ImageSize(X1,Y1,X2,Y2);
{Allocate Memory On Heap}
GetMem(Win[WinP],ImSize);
DosErr:=DosError;
If DosErr=0 Then Begin
ImX[WinP]:=X1;ImY[WinP]:=Y1;
{Get Image}
GetImage(X1,Y1,X2,Y2,Win[WinP]^);
{Draw Window}
SetLineStyle(SolidLn,0,NormWidth);
SetColor(White);
RecTangle(X1,Y1,X2,Y2);
RecTangle(X1+1,Y1+1,X2-1,Y2-1);
SetFillPattern(FloodPattern,LightGray);
Bar(X1+2,Y1+2,X2-2,Y2-2);
SetColor(Black);
Line(X1,Y2,X2,Y2);         Line(X2,Y1,X2,Y2);
SetColor(DarkGray);
Line(X1+1,Y2-1,X2-1,Y2-1); Line(X2-1,Y1+1,X2-1,Y2-1);
{Draw Caption}
SetFillPattern(FloodPattern,Blue);
Bar(X1+3,Y1+3,X2-3,Y1+15);
{Text}
SetColor(White);
SetTextStyle(15,0,0);
SetTextJustify(LeftText,TopText);
OutTextXY(X1+8,Y1+5,Caption);
CurOn;
SetViewPort(X1,Y1,639,479,True);
end
Else
Begin
CloseGraph;
WriteDosError(DosErr);
Halt(1);
End;
end;

Procedure CloseWindow;
Begin
If WinP>1 Then Begin
   CurOff;
   SetViewPort(0,0,639,479,False);
   PutImage(ImX[WinP],ImY[WinP],Win[WinP]^,NormalPut);
   FreeMem(Win[WinP],ImSize);
   WriteDosError(DosError);
   dec(WinP);
   SetViewPort(ImX[WinP],ImY[WinP],639,479,False);
   CurOn;
   End;
End;

Function Button(X1,Y1,X2,Y2:Word;Caption:String;Color:Byte;Drawed:Boolean):Boolean;
Label Redraw;
Const FloodPattern : FillPatternType = ($FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF);
Var Col1,Col2,TOfs:Byte;
    Tl,X,Y,Dx,Dy:Word;
    {Drawed:Boolean;}
    Condition,KeyDirect:Boolean;
    ViewPort:ViewPortType;
{Function GetKey:Word;
Type TypedCtrl = Set of 1..24;
Var Key,UpKey:Char;
    OutKeyVal:Word;
    Ctrl: TypedCtrl;
Begin
UpKey:=ReadKey;
If KeyPressed Then Key:=Readkey
   Else
   Key:=UpKey;
OutKeyVal:=Ord(Key);
If Key=Chr(0) Then OutKeyVal:=300+Ord(Key);
If Ord(Key) In Ctrl Then OutKeyVal:=600+Ord(Key);
GetKey:=OutKeyVal;
{Program***
If Drawed Then
 If KeyPressed Then
 Begin
 Loop:=1;
 While (Caption[Loop]<>'&') And (Caption[Loop]<>'@') And (Caption[Loop]<>'$') And (Loop<Length(Caption)) Do Inc(Loop);
 Case Caption[Loop] Of
                    '&':If Ord(Caption[Loop+1])=GetKey Then KeyDirect:=True;
                    '@':If Ord(Caption[Loop+1])=GetKey-300 Then KeyDirect:=True;
                    '$':If Ord(Caption[Loop+1])=GetKey-600 Then KeyDirect:=True;
                    End;
 Drawed:= not KeyDirect;
 End;

End;       }

Begin
Button:=False;
GetViewSettings(ViewPort);
Dx:=ViewPort.x1;
Dy:=ViewPort.y1;
Condition:=False;
Asm
mov Ax,3;
int 33h
mov Tl,Bx;
mov X,Cx;
mov Y,Dx;
End;
If (Tl=1) Then
 If ((X>X1-1+Dx) and (X<X2+1+Dx) and (Y>Y1-1+Dy) and (Y<Y2+1+Dy)) Then
   Begin
   Drawed:=False;
   Condition:=True;
   KeyDirect:=False;
   End;

If not Drawed Then
   Begin
   Redraw:
   CurOff;
   Drawed:=True;
   Col1:=15;Col2:=8;
   If Condition Then Begin Col1:=8; Col2:=15; End;
   {Left Up Coner}
   SetLineStyle(SolidLn,0,NormWidth);
   SetColor(Col1);
   Line(X1,Y1,X2,Y1); Line(X1+1,Y1+1,X2-1,Y1+1);
   Line(X1,Y1,X1,Y2); Line(X1+1,Y1+1,X1+1,Y2-1);
   {Right Down Coner}
   SetColor(Col2);
   Line(X1+1,Y2,X2,Y2); Line(X1+2,Y2-1,X2-1,Y2-1);
   Line(X2,Y1,X2,Y2); Line(X2-1,Y1+1,X2-1,Y2-1);
   {Body}
   SetFillPattern(FloodPattern,LightGray);
   Bar(X1+2,Y1+2,X2-2,Y2-2);
   {Caption}
   SetTextStyle(15,0,0);
   SetTextJustify(CenterText,CenterText);
   If not Condition Then Begin
      SetColor(DarkGray);
      OutTextXY((X1+(X2-X1) div 2)+1,(Y1+(Y2-Y1) div 2)+1,Caption);
      End;
   TOfs:=0;
   If Condition Then TOfs:=1;
   SetColor(Color);
   OutTextXY((X1+(X2-X1) div 2)+ TOfs,(Y1+(Y2-Y1) div 2)+TOfs,Caption);
   CurOn;
   Delay(5);
   Repeat
   Asm
   mov Ax,3;
   int 33h
   mov Tl,Bx;
   End;
   Until Tl=0;
   If Condition Then Begin
                     Delay(50);
                     Button:=Condition;
                     Condition:=False;
                     Goto Redraw;
                     End;
   End;
End;
{********************************}
Function CheckBox(X,Y:Word;Caption:String;Color:Byte;Condition,Drawn:Boolean):Boolean;
Const D=14;
      FloodPattern : FillPatternType = ($FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF);
Var mTl,mX,mY,Dx,Dy:Word;
      ViewPort:ViewPortType;
      Changes:Boolean;
Begin
GetViewSettings(ViewPort);
Dx:=ViewPort.x1;
Dy:=ViewPort.y1;
Asm
mov Ax,3;
int 33h
mov mTl,Bx;
mov mX,Cx;
mov mY,Dx;
End;
Changes:=not Drawn;
If (mTl=1) Then
   If ((mX>X+Dx-1) and (mX<X+D+Dx+(Length(Caption)*8)) and (mY>Y+Dy-1) and (mY<Y+D+Dy+1)) Then
      Begin
      Changes:=True;
      Case Condition Of
                     True:  Condition:=False;
                     False: Condition:=True;
                     End;
      End;

If not Drawn Then
      Begin
      CurOff;
      Drawn:=True;
      SetColor(DarkGray);
      Line(X,Y,X+D,Y); Line(X,Y+1,X+D-1,Y+1);
      Line(X,Y,X,Y+D); Line(X+1,Y,X+1,Y+D-1);
      SetColor(White);
      Line(X,Y+D,X+D,Y+D);   Line(X+1,Y+D-1,X+D,Y+D-1);
      Line(X+D,Y,X+D,Y+D);   Line(X+D-1,Y+1,X+D-1,Y+D);
      SetColor(DarkGray);
      SetTextStyle(15,0,0);
      SetTextJustify(LeftText,CenterText);
      OutTextXY(X+D+4,Y+(D div 2),Caption);
      SetColor(Color);
      OutTextXY(X+D+3,Y+(D div 2)-1,Caption);
      CurOn;
      End;
If Changes Then
      Begin
      CurOff;
      Changes:=False;
      {Erase}
      SetFillPattern(FloodPattern,LightGray);
      Bar(X+2,Y+2,X+D-2,Y+D-2);
      CurOn;
      If Condition Then
             Begin
             CurOff;
             SetColor(Color);
             SetLineStyle(SolidLn,0,NormWidth);
             SetColor(DarkGray);
             Circle(X+(D div 2)+1,Y+(D Div 2)+1,D-11);
             SetColor(Color);
             SetFillPattern(FloodPattern,Color);
             PieSlice(X+(D div 2),Y+(D Div 2),0,360,D-11);
             CurOn;
             end;
      CheckBox:=Condition;
      Repeat
      Asm
      mov Ax,3;
      int 33h
      mov mTl,Bx;
      End;
      Until mTl=0;
End;
CheckBox:=Condition;
End;
{**********************************************************
Signals
******************}
Procedure SignalsTab(X,Y:Word;TabType:TypedTabType;Active:Byte;Drawn:Boolean);
Const
      FloodPattern : FillPatternType = ($FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF);
Var
    Loop,RelX,RelY:Byte;
    ViewPort:ViewPortType;
    Dx,Dy:Byte;
Procedure CurXYOff;
Begin
Asm
mov Ax,3;
int $33;
mov mX,Cx;
mov mY,Dx;
End;
If (mX>=X+Dx-5) and (mX<=(X+280+Dx)) and (mY>=Y+Dy-5) and (mY<=(Y+143+Dy)) Then CurOff;
End;

Procedure DrawSignal(X,Y:Word;Chanel,Active:Byte;SigType:TypedTabType);
Var Sig,NBox:Byte;
    Box:Pointer;
Begin
SetColor(Yellow);
If SigType=Info Then
   Begin
   If Active>16 Then Active:=16;
   GetMem(Box,ImageSize(1,1,20,120));
   If DosError<>0 Then Begin CloseGraph;
                             Write('Memory Error');
                             End;
   CurXYOff;
   If Active>0 Then Begin
   GetImage(X+(Active*15)-15,Y,X+(Active*15),Y+120,Box^);
   PutImage(X+(Active*15)-15,Y,Box^,NotPut); End;
   If (GetPixel(X+(Active*15)-28,Y+5)=LightRed) and (Active>1) Then
                                          Begin
                                          {CurXYOff;}
                                          GetImage(X+(Active*15)-30,Y,X+(Active*15)-15,Y+120,Box^);
                                          PutImage(X+(Active*15)-30,Y,Box^,NotPut); {CurOn;}
                                          End;
   If GetPixel(X+(Active*15)+3,Y+6)=LightRed Then
                                      Begin
                                      {CurXYOff;}
                                      GetImage(X+(Active*15),Y,X+(Active*15)+15,Y+120,Box^);
                                      PutImage(X+(Active*15),Y,Box^,NotPut); {CurOn;}
                                      End;
   If (Active=0) or (not GoInZero) Then
      Begin
      If (not (GoInZero)) and (not(Active=1)) or (Active=0) Then
      If (GetPixel(X+3,Y+5)=LightRed)  Then
                                       Begin
                                       {CurXYOff;}
                                       GetImage(X,Y,X+15,Y+120,Box^);
                                       PutImage(X,Y,Box^,NotPut); {CurOn;}
                                       End;
      If (not (GoInZero)) and (not(Active=StopTC)) or (Active=0)Then
      If GetPixel(X+((StopTC)*15)-5,Y+6)=LightRed Then
                                      Begin
                                     { CurXYOff;}
                                      GetImage(X+(StopTC*15)-15,Y,X+(StopTC*15),Y+120,Box^);
                                      PutImage(X+(StopTC*15)-15,Y,Box^,NotPut);
                                     { CurOn;}
                                      End;
      End;
   FreeMem(Box,ImageSize(1,1,20,120));
   CurOn;
   End
   Else
   For Sig:=0 To (StopTC-1) Do
                 Begin
                 Case TCond[Chanel,Sig] Of
                      True: Line(X+(Sig*15),Y+2+(Chanel*15),X+15+(Sig*15),Y+2+(Chanel*15));
                      False:Line(X+(Sig*15),Y+13+(Chanel*15),X+15+(Sig*15),Y+13+(Chanel*15));
                      End;
                 If Sig<15 Then
                    If TCond[Chanel,Sig+1]<>TCond[Chanel,Sig] Then
                       Line(X+15+(Sig*15),Y+2+(Chanel*15),X+15+(Sig*15),Y+13+(Chanel*15));
                 End;
End;

Procedure Item(X,Y:Word;Caption:String);
Begin
SetColor(White);
SetLineStyle(SolidLn,0,NormWidth);
Line(X,Y+1,X+24,Y+1);
Line(X,Y+1,X,Y+14);
SetColor(DarkGray);
Line(X,Y+14,X+24,Y+14);
Line(X+24,Y+1,X+24,Y+14);
SetTextStyle(2,0,0);
SetTextJustify(CenterText,TopText);
SetColor(Black);
OutTextXY(X+12,Y+1,Caption);
End;

Begin
GetViewSettings(ViewPort);
Dx:=ViewPort.x1;
Dy:=ViewPort.y1;
If not Drawn Then
Begin
CurOff;
SetFillPattern(FloodPattern,Cyan);
Bar(X+25,Y+15,X+265,Y+135);
SetColor(Black);
SetLineStyle(UserBitLn,$AAAA,NormWidth);
For Loop:=1 To 15 Do
                  Line(X+25+(Loop*15),Y+15,X+25+(Loop*15),Y+135);
SetLineStyle(SolidLn,0,NormWidth);
SetColor(Black);
For Loop:=1 To 7 Do
                  Line(X+25,Y+15+(Loop*15),X+265,Y+15+(Loop*15));
For Loop:=0 To 7 Do
                  Begin
                  Str(Loop,StrUser);
                  Item(X,Y+15+(Loop*15),'Ch'+StrUser);
                  End;
{Draw Signals}
For Loop:=0 To 7 Do
                 DrawSignal(X+25,Y+15,Loop,0,Settings);
End;

If TabType=Info Then
                   DrawSignal(X+25,Y+15,0,Active,Info);

If TabType=Settings Then
                Begin
                Asm
                mov Ax,3;
                int $33;
                mov mTl,Bx;
                mov mX,Cx;
                mov mY,Dx;
                End;
                If (mX>(Dx+X+25)) and (mY>(Dy+Y+15)) Then
                Begin
                RelX:=(mX-(Dx+X+25)) div 15;
                RelY:=(mY-(Dy+Y+15)) div 15;
                If (mTl=1) and (RelX<16) and (RelY<8) Then
                  Begin
                  SetColor(Cyan);
                  CurOff;
                  If RelX<=StopTC-1 Then
                  Begin
                  Case TCond[RelY,RelX] Of
                      True: Line(X+25+(RelX*15),Y+17+(RelY*15),X+40+(RelX*15),Y+17+(RelY*15));
                      False:Line(X+25+(RelX*15),Y+28+(RelY*15),X+40+(RelX*15),Y+28+(RelY*15));
                      End;
                  Case TCond[RelY,RelX] Of
                                        True:TCond[RelY,RelX]:=False;
                                        False:TCond[RelY,RelX]:=True;
                                        End;

                  SetColor(Yellow);
                  Case TCond[RelY,RelX] Of
                      True: Line(X+25+(RelX*15),Y+17+(RelY*15),X+40+(RelX*15),Y+17+(RelY*15));
                      False:Line(X+25+(RelX*15),Y+28+(RelY*15),X+40+(RelX*15),Y+28+(RelY*15));
                      End;
                  End;
                  CurOn;
                  Repeat
                  Asm
                  mov Ax,3;
                  int $33;
                  mov mTl,Bx;
                  End;
                  Until mTl=0;
                  End;
                 End;
                End;
CurOn;
End;

Function ValuePointer(X,Y:Word;Values,LV,InValue:Byte;Drawn:Boolean):Byte;
Const
      FloodPattern : FillPatternType = ($FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF);
Var
   Loop:Byte;
   Value,OldValue:Byte;
   mTl,mX,mY,Dx,Dy:Word;
   ViewPort:ViewPortType;
Begin
Value:=InValue;
OldValue:=InValue;
GetViewSettings(ViewPort);
Dx:=ViewPort.x1;
Dy:=ViewPort.y1;
Asm
mov Ax,3;
int $33;
mov mTl,Bx;
mov mX,Cx;
mov mY,Dx;
End;
If (mTl=1) Then
   If (mX>=X+Dx-4) and (mX<=X+(Values*LV)+Dx) and (mY>=Y-5+Dy) and (mY<=Y+14+Dy) or (not Drawn) Then
         Begin
         Value:=((mX-(Dx+X-4)) div LV);
         {If OldRelX> Values Then OldRelX:=0;}
         If OldValue<>Value Then
                Begin
                CurOff;
                SetFillPattern(FloodPattern,LightGray);
                Bar(X+(OldValue*LV)-4,Y-6,X+(OldValue*LV)+4,Y+10);
                Drawn:=False;
                End;
         End;

If not Drawn Then
Begin
CurOff;
OldRelX:=Value;
SetColor(Black);
Line(X,Y+10,X+(Values*LV),Y+10);
For Loop:=0 To Values Do
    Line(X+(Loop*LV),Y+8,X+(Loop*LV),Y+12);
SetColor(DarkGray);
Line(X,Y,X+(Values*LV),Y);
SetColor(White);
Line(X,Y+1,X+(Values*LV),Y+1);
Line(X+(Value*LV)-3,Y-6,X+(Value*LV)+3,Y-6);
Line(X+(Value*LV)-3,Y-6,X+(Value*LV)-3,Y+5);
Line(X+(Value*LV)-3,Y+5,X+(Value*LV),Y+8);
SetColor(DarkGray);
Line(X+(Value*LV)+3,Y-6,X+(Value*LV)+3,Y+5);
Line(X+(Value*LV)+3,Y+5,X+(Value*LV),Y+8);
SetColor(LightGray);
Line(X+(Value*LV)-2,Y+1,X+(Value*LV)+2,Y+1);
Line(X+(Value*LV)-2,Y,X+(Value*LV)+2,Y);
End;
CurOn;
ValuePointer:=Value;
End;

{*********************** Frame **************************}
Procedure Frame(X1,Y1,X2,Y2:Word;Caption:String);
Begin
CurOff;
SetColor(DarkGray);
{inline}
Line(X1,Y1,X1+5,Y1); Line(X1+(Length(Caption)*8)+12,Y1,X2,Y1);
Line(X1,Y1,X1,Y2);
{}
Line(X1+2,Y2-1,X2-1,Y2-1); Line(X2-1,Y1+1,X2-1,Y2-1);
SetColor(White);
{}
Line(X1+1,Y1+1,X1+5,Y1+1); Line(X1+(Length(Caption)*8)+12,Y1+1,X2-1,Y1+1);
Line(X1+1,Y1+1,X1+1,Y2-1);
{inline}
Line(X1+1,Y2,X2,Y2); Line(X2,Y1+1,X2,Y2);

SetColor(Black);
SetTextStyle(15,0,0);
SetTextJustify(LeftText,CenterText);
OutTextXY(X1+9,Y1+2,Caption);
CurOn;
End;
Procedure Dialog(X,Y:Word;Caption,Message:String);
Var Dx,Dy:Word;
Begin
OpenWindow(X,Y,X+(Length(Message)*8)+40,Y+80,Caption);
SetTextStyle(15,0,1);
SetTextJustify(LeftText,TopText);
SetColor(DarkGray);
CurOff;
OutTextXY(21,31,Message);
SetColor(Yellow);
OutTextXY(20,30,Message);
CurOn;
Button(((Length(Message)*8+20) div 2)-20,50,((Length(Message)*8+40) div 2)+20,70,'OK',LightRed,False);
Repeat
Until Button(((Length(Message)*8+20) div 2)-20,50,((Length(Message)*8+40) div 2)+20,70,'OK',LightRed,True);
CloseWindow;
End;

{
*************************************************************************
*************************************************************************
********************    OUTPUT ROUTINES   *******************************
*************************************************************************
}
Function GetBinary(NBit:Byte):Byte;
Var Bin,Expo:Byte;
Begin
Bin:=1;
For Expo:=0 To NBit Do
               Bin:=Bin*2;
GetBinary:=Bin;
End;

Procedure SendData(TC:Byte);
Var
   OutData,Ch:Byte;
   N:Word;
Begin
OutData:=0;
If SDP Then
 For Ch:=0 To 7 Do
            If TCond[Ch,TC] Then
               OutData:=OutData+GetBinary(Ch);
{Port(PortAdress):=OutData;}
End;
Procedure SetData;
Var Bit,OutData:Byte;
Begin
OutData:=0;
If SDP Then
 For Bit:=0 To 7 Do
           If SCond[Bit] Then
              OutData:=OutData+GetBinary(Bit);
{Port(PortAdress):=OutData;}
End;
Procedure PortOff;
Begin
{Port(PortAdress+1):=0;}
End;
Procedure PortOn;
Begin
If SDP Then
{Port(PortAdress+1):=1}
End;
{**************************** I/O HDD *****************************}
Procedure SaveConditions(SavingWay:SWs);
Var F:Text;
    Ch,wTC:Byte;
    Chan:String[2];
Function BoolChar(Bool:Boolean):Char;
Begin
Case Bool Of
     True:BoolChar:='1';
     False:BoolChar:='0';
   End;
End;

Begin
{ChDir(PATH);}
Assign(F,FileName);
Rewrite(F);
WriteLn(F,'* * * * * * * * Step Motors Satus * * * * * * * * *');
Writeln(F,'File Name In Created :',FileName);
Writeln(F,'Conditions Tab Name :',CondName);
For Ch:=0 To 7 Do
    Begin
    Str(Ch,Chan);
    Write(F,'Ch_',Chan,':[');
    For wTC:=1 To StopTC Do
               Write(F,BoolChar(TCond[Ch,wTC-1]));
    Write(F,']');
    Writeln(F,'');
    End;
WriteDosError(DosError);
Close(F);
End;

Procedure LoadConditions;
Label ErrEnd;
Var F:Text;
    BoolCh:Char;
    wTC,Loop,Loop2,Ch:Byte;
    CondLine:String[23];
    NameLine:String[60];
Function BoolVal(BChar:Char):Boolean;
Begin
BoolVal:=False;
Case BChar Of
     '0':BoolVal:=False;
     '1':BoolVal:=True;
     End;
End;
Begin
Assign(F,FileName);
Reset(F);
If IOResult<>0 Then
                  Begin
                  GetDir(0,PATH);
                  ChDir(PATH);
                  Dialog(190,200,'MS DOS Error','FILE Not Found');
                  End;
ReadLn(F);
ReadLn(F);
ReadLn(F,NameLine);
Loop:=1;
Repeat
inc(Loop);
Until (NameLine[Loop]=':') or (Loop>22);
Loop2:=1;
Repeat
CondName[Loop2]:=NameLine[Loop+Loop2];
inc(Loop2);
Until (NameLine[Loop+Loop2]='') or (Loop2>23);
Ch:=0;
Repeat
    ReadLn(F,CondLine);
    wTC:=0;
    Repeat
           If (CondLine[wTC+7]='1') Or (CondLine[wTC+7]='0') Then
                                    TCond[Ch,wTC]:=BoolVal(CondLine[wTC+7]);
    Inc(wTC);
    Until (wTC>15) or (CondLine[wTC+6]=']');
    inc(Ch);
Until Eof(F) or (Ch>7);
StopTC:=wTC;
Close(F);
End;

{******************* Read Text ***********************}
Function ReadText(Xpos,Ypos,TextLength:Word;ItemText,PredefinedText:String):String;
Const Pattern : FillPatternType =($FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF);
Var TextPtr:Byte;
    InsertMode:Boolean;
    Wait:Byte;
    Inx,OldInx,Save:Byte;
    MouseBlock:Boolean;
    RText:String;
    Ch:Char;
    NormalInput:Boolean;
Begin
OpenWindow(Xpos,Ypos,Xpos+(TextLength*8)+42,Ypos+80,ItemText);
Button(25,50,70,70,'Ok',LightGreen,False);
Button(90,50,150,70,'Cancel',LightRed,False);
CurOff;
SetColor(White);
Line(20,40,24+(TextLength*8),40);
Line(24+(TextLength*8),27,24+(TextLength*8),40);
SetColor(DarkGray);
Line(20,27,24+(TextLength*8),27);
Line(20,28,20,40);
SetColor(Black);
SetTextJustify(LeftText,TopText);
OuttextXY(23,30,PredefinedText);
CurOn;
RText:=PredefinedText;
InsertMode:=False;
MouseBlock:=False;
TextPtr:=1;
Inx:=1;
Repeat
If KeyPressed Then
                 Begin
                 Ch:=ReadKey;
                 NormalInput:=True;
                 Case ord(Ch) Of
                                0:Begin
                                  Ch:=ReadKey;
                                  NormalInput:=False;
                                  Case ord(Ch) Of
                                  {Operators}
                                                 75:TextPtr:=TextPtr-1; {Left}
                                                 77:TextPtr:=TextPtr+1; {Right}
                                                 80:TextPtr:=1;         {Down}
                                                 72:TextPtr:=Length(RText)+1;{Up}
                                                 71:TextPtr:=1;         {Home}
                                                 79:TextPtr:=Length(RText)+1;{End}
                                                 82:Case InsertMode Of  {Insert}
                                                                     True: InsertMode:=False;
                                                                     False:InsertMode:=True;
                                                                     End;
                                                 83:Begin Case MouseBlock Of
                                                                    False:Delete(RText,TextPtr,1); {Delete}
                                                                    True :Begin
                                                                          Delete(RText,TextPtr,Inx);
                                                                          MouseBlock:=False;
                                                                          Inx:=1;
                                                                          End;
                                                   End;
                                                   NormalInput:=True;
                                                   End;
                                                 End;
                                  End;
                                8:Begin
                                  Delete(RText,TextPtr-1,1);{BackSpace}
                                  TextPtr:=TextPtr-1;
                                  End;
                                 {Text}
                                32..253:
                                        Case InsertMode Of
                                                           True: Begin
                                                                 RText[TextPtr]:=Ch;
                                                                 TextPtr:=TextPtr+1;
                                                                 End;
                                                           False:Begin
                                                                 Insert(Ch,RText,TextPtr);
                                                                 TextPtr:=TextPtr+1;
                                                                 End;
                                                           End;
                     End;
                     If TextPtr<1 Then TextPtr:=1;
                     If TextPtr>(TextLength) Then TextPtr:=TextLength;
                     RText[TextLength]:=Chr(0);
                     SetColor(LightGray);
                     {If NormalInput Then Begin}
                     SetFillPattern(Pattern,LightGray);
                     CurOff;
                     Bar(23,28,TextLength*8+23,38);
                     SetColor(Black);
                     OutTextXY(23,30,RText);
                     CurOn;
                     {End;}
                     End;

Wait:=Wait+1;
Delay(1);
Case Wait Of
           100:SetColor(Black);
           200:SetColor(LightGray);
          End;

If Wait>200 Then Wait:=0;
   Line(TextPtr*8+15,38,TextPtr*8+15+6,38);
If Button(25,50,70,70,'Ok',LightGreen,True) Then Ch:=Chr(13);
If Button(90,50,150,70,'Cancel',LightRed,True) Then Ch:=Chr(27);
Until (Ch=char(13)) or (Ch=char(27));
Case Ord(Ch) Of
        13: ReadText:=RText;
        27: ReadText:='';
        End;
CloseWindow;
Ch:=Chr(0);
end;

Procedure Text3DXY(X,Y:Word;Color,Size:Byte;Text:String);
Begin
SetColor(DarkGray);
SetTextStyle(7,0,Size);
SetTextJustify(LeftText,TopText);
OutTextXY(X+4,Y+4,Text);
SetColor(Color);
OutTextXY(X+2,Y+2,Text);
SetColor(Color+8);
OutTextXY(X,Y,Text);
End;
{
*************************************************************************
************                BEGIN                  ***           ********
*************************************************************************
}
Begin
TextColor(Yellow);
Writeln;
Writeln('Mouse Check Instalation');
Delay(300);
Asm
mov Ax,00h;
int 33h;
mov MouseInst,Ax;
End;
TextColor(Red);
If MouseInst=0 Then Begin WriteLn('Mouse Not Installed, Please Install Mouse Driver');
                    Halt(1);
                    End;
Delay(100);
TextColor(Yellow);
WriteLn;
WriteLn('Initializing Graph');
Delay(200);
WriteLn;
TextColor(Green);
WriteLn('Using Enhanced Graphic Adapter EGA/VGA - 640*480 16 Colors');
Delay(300);
TextColor(White);
WriteLn('Using IRQ 8 - As Timer');
Delay(800);
InitGraph(gm,gd,'C:\petrik\bp\bgi');
If GraphResult<>0 Then Begin
                       TextColor(Red);
                       Writeln('Graph Error Ocurrs - Graph Driver Not Found');
                       Halt(1);
                       End;
Randomize;
{**************** Get Old Int Vectors **********************}
GetIntVec($8,OldTimerPtr);
GetIntVec($8,@OldTimer8);
Delay(300);
{***************** Set New Int Vectors **************}
{Dialog(250,200,'Mem Operation','Putting new Interrup');}
SetIntVec(8,Addr(Pulser));

{*************** LOGO ****************}
SetColor(Blue);
SetTextStyle(7,0,5);
SetTextJustify(LeftText,TopText);
Text3DXY(180,100,Red,5,'Welcome To');
Text3DXY(230,200,Blue,5,'Cyber`s');
Text3DXY(180,300,Green,5,'Laboratory');
Delay(2000);
ClearDevice;
{************* Laboratory BackGround **************}
SetColor(DarkGray);
SetTextStyle(7,0,4);
For Loop:=0 To 14 Do
    Text3DXY(50,10+Loop*30,Random(7)+1,4,'Cyber`s PC-Electronic Laboratory');
CurOn;
SetCursor(Seg(Arrow),Ofs(Arrow));
{************ Defaults Values *********************}
WinP:=0;
StopTC:=16;
FileName:='Motor1.stp';
StepRepSEQ:=False;
GoInZero:=True;
PAP:=LPT1;
Speed:=10;
{**************************************}
CondName:='Step Motors Conditions #1';
OpenWindow(180,150,392,330,'Step Motors Driver');
Button(15,140,110,170,'Conditions',LightBlue,False);
Button(150,140,200,170,'Exit',LightRed,False);
Button(20,40,100,80,'Set Port',Yellow,False);
Button(115,40,190,80,'Step',LightGreen,False);
RepeatSeq:=False;
CheckBox(40,89,'LPT1',Yellow,True,False);
CheckBox(120,89,'LPT2',Yellow,False,False);
CheckBox(20,109,'Send Data On Port',White,SDP,False);
Frame(10,30,200,130,'Output Generator');
{**********************************}

Repeat
SDP:=CheckBox(20,109,'Send Data On Port',White,SDP,True);
{******* Choose LPTs ***************}
If CheckBox(40,89,'LPT1',Yellow,False,True) Then
Begin
CheckBox(120,89,'LPT2',Yellow,False,False);
PAP:=LPT1;
End;
If CheckBox(120,89,'LPT2',Yellow,False,True) Then
Begin
CheckBox(40,89,'LPT1',Yellow,False,False);
PAP:=LPT2;
End;
{************Choose LPTs ****************}
If Button(15,140,110,170,'Conditions',LightBlue,True) Then
                   Begin
                   OpenWindow(100,150,472,330,'Set Time Conditions');
                   NChanels:='Chanel ';
                   Frame(11,30,360,110,'Chanels');
                   For Loop:=0 To 3 Do
                       Begin
                       Str(Loop,StrUser);
                       StrUser:=NChanels+StrUser;
                       Button(20+(Loop*85),40,95+(Loop*85),65,StrUser,Yellow,False);
                       Str(Loop+4,StrUser);
                       StrUser:=NChanels+StrUser;
                       Button(20+(Loop*85),75,95+(Loop*85),100,StrUser,Yellow,False);
                       End;
                   Button(20,130,130,160,'Graphic Form',LightGreen,False);
                   Button(290,130,350,160,'Cancel',LightRed,False);
                   Frame(145,118,275,170,'Save & Load');
                   Button(155,130,205,160,'Save',LightBlue,False);
                   Button(215,130,265,160,'Load',LightGreen,False);
                   Result:=0;
                   NChanels:='Chanel ';
                   Repeat
                   {***************************}
                   If Button(155,130,205,160,'Save',LightBlue,True) Then Begin
                         CondNameTMP:=ReadText(150,270,40,'Enter Condition Name',CondName);
                         If CondNameTMP<>'' Then
                            Begin
                            CondName:=CondNameTMP;
                            FileNameTMP:=ReadText(200,270,20,'Enter File Name ...',FileName);
                            If FileNameTMP<>'' Then
                                            Begin
                                            FileName:=FileNameTMP;
                                            SaveConditions(swRewrite);
                                            End;
                            End;
                         End;

                   If Button(215,130,265,160,'Load',LightGreen,True) Then  Begin
                         GetDir(0,PATH);
                         PATH:=ReadText(2,270,70,'Enter Path',PATH);
                         ChDir(PATH);
                         If IOResult<>0 Then
                           Begin
                             GetDir(0,PATH);
                             ChDir(PATH);
                             Dialog(190,200,'MS DOS Error','PATH Not Found');
                             End
                          Else
                          Begin
                         If PATH<>'' Then
                            Begin
                            FileName:=ReadText(0,270,20,'Enter File Name ...','Motor1.stp');
                            If FileName<>'' Then
                                            LoadConditions;
                            End;
                          End;
                         End;
                      {************************}

                   For Loop:=0 To 3 Do
                       Begin
                       Str(Loop,StrUser);
                       StrUser:=NChanels+StrUser;
                       If Button(20+(Loop*85),40,95+(Loop*85),65,StrUser,Yellow,True) Then
                          Result:=Loop+1;
                       Str(Loop+4,StrUser);
                       StrUser:=NChanels+StrUser;
                       If Button(20+(Loop*85),75,95+(Loop*85),100,StrUser,Yellow,True) Then
                          Result:=Loop+4+1;
                       End;
                   If Result>0 Then
                      Begin
                      For Loop:=0 To 15 Do
                          TMPCond[loop]:=TCond[Result-1,loop];
                      Str(Result-1,StrUser);
                      StrUser:=NChanels+StrUser;
                      OpenWindow(200,50,290,435,StrUser);
                      Button(10,320,70,345,'Cancel',LightRed,False);
                      Button(10,350,70,375,'OK',LightGreen,False);
                      For Loop:=0 To 15 Do
                          Begin
                          Str(Loop,StrUser);
                          CheckBox(10,25+(Loop*18),'tc '+StrUser,Yellow,TCond[Result-1,Loop],False);
                          End;
                      {Scaning}
                      Repeat
                       Loop:=0;
                       Repeat
                       TMPCond[Loop]:=CheckBox(10,25+(Loop*18),'NoDef',Yellow,TMPCond[Loop],True);
                       Inc(Loop);
                       Until Loop>15;

                      ExCode:=0;
                      If Button(10,320,70,345,'Cancel',LightRed,True) Then ExCode:=1;
                      If Button(10,350,70,375,'OK',LightGreen,True) Then ExCode:=2;
                      Until ExCode<>0;
                      If ExCode = 2 Then For Loop:=0 To 15 Do
                                             TCond[Result-1,Loop]:=TMPCond[Loop];
                      CloseWindow;
                      Result:=0;
                      End;
                   {Graphic Form}
                   If Button(20,130,130,160,'Graphic Form',LightGreen,True) Then
                      Begin
                      OpenWindow(150,140,450,350,'Visual Conditions Settings');
                      SignalsTab(10,21,Settings,5,False);
                      StopTC:=ValuePointer(57,23,14,15,(StopTC-2),False)+2;
                      Button(190,165,270,190,'OK',LightGreen,False);
                      Repeat
                      Loop:=StopTC;
                      StopTC:=ValuePointer(57,23,14,15,(StopTC-2),True)+2;
                      SignalsTab(10,21,Settings,5,True);
                      If StopTC<>Loop Then SignalsTab(10,21,Settings,5,False);
                      Until Button(190,165,270,190,'OK',LightGreen,True);
                      CloseWindow;
                      End;
                      If KeyPressed Then Key:=Readkey;
                   Until Button(290,130,350,160,'Cancel',LightRed,True) or (Key=Chr(27));
                   Key:=Chr(0);
                   CloseWindow;
                   End;
If Button(20,40,100,80,'Set Port',Yellow,True) Then
                   Begin
                   OpenWindow(140,200,435,290,'Set Port Conditions');
                   Button(200,55,280,80,'Cancel',LightRed,False);
                   For Loop:=0 To 7 Do Begin
                       Str(Loop, NChanels);
                       CheckBox(20+(Loop*30),30,NChanels,Green,SCond[Loop],False);
                       End;
                   Repeat
                   For Loop:=0 To 7 Do Begin
                       Str(Loop, NChanels);
                       SCond[Loop]:=CheckBox(20+(Loop*30),30,NChanels,Green,SCond[Loop],True);
                       End;
                   If KeyPressed Then Begin
                                      Key:=Readkey;
                                      If (Key=Chr(27)) Then
                                      Begin
                                      {PortOFF;}
                                      Dialog(200,190,'Process Message :','Process Stoped, Port OFF');
                                      GoTo CrashExit;
                                      End;
                                      End;
                   Until Button(200,55,280,80,'Cancel',LightRed,True);
                   CrashExit:
                   Key:=Chr(0);
                   CloseWindow;
                   End;
If Button(115,40,190,80,'Step',LightGreen,True) Then
                   Begin
                   OpenWindow(150,100,460,340,'Step Logic Pulse Generator');
                   StopTC:=ValuePointer(57,23,14,15,(StopTC-2),False)+2;
                   SignalsTab(10,21,Info,0,False);
                   Button(10,165,60,190,'Reset',LightBlue,False);
                   Button(67,165,123,190,'< Back',Yellow,False);
                   Button(124,165,179,190,'Next >',Yellow,False);
                   Button(185,165,235,190,'Trase',LightGreen,False);
                   Button(245,165,300,190,'Cancel',LightRed,False);
                   StepRepSEQ:=CheckBox(180,200,'Repeat Seq.',Yellow,StepRepSEQ,False);
                   GoInZero:=CheckBox(180,220,'Go In Zero',White,GoInZero,False);
                   Speed:=ValuePointer(15,205,15,10,Speed,False);
                   Trase:=False;
                   TC:=0;
                   WaitSeq:=0;
                   Repeat
                   If Redraw Then Begin SignalsTab(10,21,Info,TC,True); Redraw:=False; End;
                   If KeyPressed Then Begin
                                      Key:=Readkey;
                                      If ((Key=Chr(27)) or (Key=Chr(13))) and Trase Then
                                      Begin
                                      {PortOFF;}
                                      Trase:=False;
                                      TC:=0;
                                      SignalsTab(10,21,Info,0,False);
                                      CurOff;
                                      SetCursor(Seg(Arrow),Ofs(Arrow));
                                      CurOn;
                                      Dialog(200,200,'Process Message :','Process Stoped, Port OFF');
                                      Key:=Chr(0);
                                      End;
                                      End;
                   Loop:=StopTC;
                   StopTC:=ValuePointer(57,23,14,15,(StopTC-2),True)+2;
                   If StepRepSEQ Then
                                 GoINZero:=CheckBox(180,220,'Go In Zero',White,GoInZero,True);
                   If (not StepRepSEQ) and (not GoInZero) Then Begin
                                                         GoInZero:=True;
                                                         CheckBox(180,220,'Go In Zero',White,True,False);
                                                         End;
                      If GoInZero Then  StartTC:=0
                                  Else  StartTC:=1;

                   If Loop<>StopTC Then Begin SignalsTab(10,21,Info,0,False); TC:=0; End;
                   StepRepSEQ:=CheckBox(180,200,'Repeat Seq.',Yellow,StepRepSEQ,True);
                   Speed:=ValuePointer(15,205,15,10,Speed,True);
                   {< Back}
                   If not Trase Then
                      If Button(67,165,123,190,'< Back',Yellow,True) Then dec(TC);
                   {Next >}
                   If not Trase Then
                      If Button(124,165,179,190,'Next >',Yellow,True) Then inc(TC);
                   If not Trase Then
                      Case GoInZero Of
                                     True: Begin
                                           If TC=255 Then TC:=StopTC;
                                           If TC>StopTC Then TC:=0;
                                           End;
                                     False:Begin
                                           If TC<1 Then TC:=StopTC;
                                           If TC>StopTC Then TC:=1;
                                           End;
                                     End;
                   If not Trase Then
                                Begin
                                If TC<>OldTC Then
                                     SignalsTab(10,21,Info,TC,True);
                                     OldTC:=TC;
                                End;
                   If Button(10,165,60,190,'Reset',LightBlue,True) Then
                      Begin
                      TC:=0;
                      Trase:=False;
                      SignalsTab(10,21,Info,TC,False);
                      CurOff;
                      SetCursor(Seg(Arrow),Ofs(Arrow));
                      CurOn;
                      End;

                   If Button(185,165,235,190,'Trase',LightGreen,True) Then
                                            Begin
                                            Trase:=True;
                                            CurOff;
                                            SetCursor(Seg(Traser),Ofs(Traser));
                                            CurOn;
                                            End;
                   If KeyPressed and not Trase Then Key:=Readkey;
                   Until Button(245,165,300,190,'Cancel',LightRed,True) or ((Key=Chr(27)) and (not Trase));
                   {PortOff;}
                   Trase:=False;
                   CloseWindow;
                   Key:=Chr(0);
                   CurOff;
                   SetCursor(Seg(Arrow),Ofs(Arrow));
                   CurOn;
                   End;
If KeyPressed Then Key:=Readkey;
If Button(150,140,200,170,'Exit',LightRed,True) or (Key=Chr(27)) Then
                   Begin
                   Key:=Chr(0);
                   OpenWindow(210,180,375,280,'Realy Exit ?');
                   YesExit:=False;
                   NoExit:=False;
                   YesExit:=Button(20,40,70,70,'Yes',LightRed,False);
                   NoExit:=Button(90,40,140,70,'No',LightGreen,False);
                   Repeat
                   YesExit:=Button(20,40,70,70,'Yes',LightRed,True);
                   NoExit:=Button(90,40,140,70,'No',LightGreen,True);
                   If KeyPressed Then Key:=Readkey;
                   Until YesExit or NoExit or (Key=Chr(27)) or (Key=Chr(13));
                   If Key=Chr(13) Then YesExit:=True;
                   Key:=Chr(0);
                   CloseWindow;
                   End;
Until YesExit;
CloseWindow;
Delay(100);
{**************** Set Old Int Vectors **********************}
SetIntVec($8,OldTimerPtr);
{*******************************}

CloseGraph;
Delay(500);
Writeln;
Writeln;
Writeln('Cyber (R)  Logic Power Pulse Generator on LPT prn');
Writeln('                                    by Peter Sladek');
Writeln('     (C)Copyright Cyber Corp. 1998-? ...Well it`s a question...');
Writeln;
Delay(1000);
End.


